"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.HtmlPathImpl = void 0;
const autobind_decorator_1 = __importDefault(require("autobind-decorator"));
const assert_1 = __importDefault(require("assert"));
const booleanHelpers_1 = require("./boolean/booleanHelpers");
const integerHelpers_1 = require("./integer/integerHelpers");
const linkHelpers_1 = require("./link/linkHelpers");
const fileHelpers_1 = require("./file/fileHelpers");
const iteratorHelpers_1 = require("./iterator/iteratorHelpers");
const stringHelpers_1 = require("./string/stringHelpers");
let HtmlPathImpl = class HtmlPathImpl {
    constructor(config) {
        this.config = config;
    }
    toString() {
        return stringHelpers_1.toString(this.config.node);
    }
    toRaw() {
        return this.config.$.html(this.config.node);
    }
    toInteger() {
        return integerHelpers_1.toInteger(this.config.node);
    }
    toBoolean() {
        return booleanHelpers_1.toBoolean(this.config.node);
    }
    toArray() {
        const paths = [];
        for (const path of this) {
            paths.push(path);
        }
        return paths;
    }
    toLink() {
        return linkHelpers_1.toLink(this.config.node);
    }
    toFile() {
        if (!this.config.file) {
            throw new Error('files not configured');
        }
        return fileHelpers_1.toFile(this.config.file, this);
    }
    toImage() {
        if (!this.config.image) {
            throw new Error('images not configured');
        }
        // @ts-expect-error
        const uniqueSelector = this.config.node.getUniqueSelector();
        assert_1.default(typeof uniqueSelector === 'string');
        return this.config.image.create(uniqueSelector);
    }
    get(selector) {
        return this.config.provide(this.config.node.find(selector));
    }
    [Symbol.iterator]() {
        return iteratorHelpers_1.toIterator(this.config);
    }
    valueOf() {
        return this.toRaw();
    }
};
HtmlPathImpl = __decorate([
    autobind_decorator_1.default
], HtmlPathImpl);
exports.HtmlPathImpl = HtmlPathImpl;
//# sourceMappingURL=htmlFacade.js.map