"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Html = void 0;
const cheerio_1 = require("cheerio");
const cheerio_get_css_selector_1 = __importDefault(require("cheerio-get-css-selector"));
const htmlFacade_1 = require("./htmlFacade");
function Html(content = '', selector, config = {}) {
    const $ = cheerio_1.load(content);
    cheerio_get_css_selector_1.default.init($);
    const provide = (inner) => {
        let node;
        if (typeof inner === 'string') {
            node = $(inner);
        }
        else if (typeof inner === 'object') {
            node = $(inner);
        }
        else {
            node = $.root();
        }
        const instance = new htmlFacade_1.HtmlPathImpl(Object.assign(Object.assign({}, config), { $, node, provide }));
        return proxify(instance);
    };
    return provide(selector);
}
exports.Html = Html;
function proxify(value) {
    return new Proxy(value, {
        get(target, prop) {
            if (prop in target || typeof prop === 'symbol') {
                // @ts-expect-error
                return Reflect.get(...arguments);
            }
            return value.get(prop.toString());
        },
    });
}
//# sourceMappingURL=htmlProvider.js.map